if (!defined &_NFS_NFS_CLNT_H) {
    eval 'sub _NFS_NFS_CLNT_H {1;}';
    require 'sys/kstat.ph';
    require 'vm/page.ph';
    require 'sys/thread.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub HOSTNAMESZ {32;}';
    eval 'sub ACREGMIN {3;}';
    eval 'sub ACREGMAX {60;}';
    eval 'sub ACDIRMIN {30;}';
    eval 'sub ACDIRMAX {60;}';
    eval 'sub ACMINMAX {3600;}';
    eval 'sub ACMAXMAX {36000;}';
    eval 'sub NFS_CALLTYPES {3;}';
    eval 'sub ENFS_TRYAGAIN {999;}';
    if (defined &DEBUG) {
    }
    eval 'sub a_nfs_readahead { &a_args. &a_read_args. &readahead;}';
    eval 'sub a_nfs_blkoff { &a_args. &a_read_args. &blkoff;}';
    eval 'sub a_nfs_seg { &a_args. &a_read_args. &seg;}';
    eval 'sub a_nfs_addr { &a_args. &a_read_args. &addr;}';
    eval 'sub a_nfs_putapage { &a_args. &a_pageio_args. &pageio;}';
    eval 'sub a_nfs_pageio { &a_args. &a_pageio_args. &pageio;}';
    eval 'sub a_nfs_pp { &a_args. &a_pageio_args. &pp;}';
    eval 'sub a_nfs_off { &a_args. &a_pageio_args. &io_off;}';
    eval 'sub a_nfs_len { &a_args. &a_pageio_args. &io_len;}';
    eval 'sub a_nfs_flags { &a_args. &a_pageio_args. &flags;}';
    eval 'sub a_nfs_readdir { &a_args. &a_readdir_args. &readdir;}';
    eval 'sub a_nfs_rdc { &a_args. &a_readdir_args. &rdc;}';
    eval 'sub a_nfs_commit { &a_args. &a_commit_args. &commit;}';
    eval 'sub a_nfs_plist { &a_args. &a_commit_args. &plist;}';
    eval 'sub a_nfs_offset { &a_args. &a_commit_args. &offset;}';
    eval 'sub a_nfs_count { &a_args. &a_commit_args. &count;}';
    eval 'sub VFTOMI {
        local($vfsp) = @_;
        eval "(( &mntinfo_t *)(($vfsp)-> &vfs_data))";
    }';
    eval 'sub VTOMI {
        local($vp) = @_;
        eval "(( &mntinfo_t *)((($vp)-> &v_vfsp)-> &vfs_data))";
    }';
    eval 'sub MI_HARD {0x1;}';
    eval 'sub MI_PRINTED {0x2;}';
    eval 'sub MI_INT {0x4;}';
    eval 'sub MI_DOWN {0x8;}';
    eval 'sub MI_NOAC {0x10;}';
    eval 'sub MI_NOCTO {0x20;}';
    eval 'sub MI_DYNAMIC {0x40;}';
    eval 'sub MI_LLOCK {0x80;}';
    eval 'sub MI_GRPID {0x100;}';
    eval 'sub MI_RPCTIMESYNC {0x200;}';
    eval 'sub MI_LINK {0x400;}';
    eval 'sub MI_SYMLINK {0x800;}';
    eval 'sub MI_READDIR {0x1000;}';
    eval 'sub MI_ACL {0x2000;}';
    eval 'sub MI_TRYANON {0x4000;}';
    eval 'sub PURGE_ATTRCACHE {
        local($vp) = @_;
        eval " &VTOR($vp)-> &r_attrtime =  &hrestime. &tv_sec";
    }';
    eval 'sub ATTRCACHE_VALID {
        local($vp) = @_;
        eval " &hrestime. &tv_sec <  &VTOR($vp)-> &r_attrtime";
    }';
    eval 'sub PURGE_STALE_FH {
        local($errno, $vp, $cr) = @_;
        eval " &if (($errno) ==  &ESTALE) { \'struct rnode\' * &rp =  &VTOR($vp);  &mutex_enter(& &rp-> &r_statelock);  &rp-> &r_flags |=  &RDONTWRITE;  &if (! &rp-> &r_error)  &rp-> &r_error =  &error;  &mutex_exit(& &rp-> &r_statelock);  &if (($vp)-> &v_pages !=  &NULL)  &nfs_invalidate_pages(($vp), 0, ($cr));  &nfs_purge_caches(($vp), ($cr)); }";
    }';
    eval 'sub CACHE_VALID {
        local($rp, $mtime, $fsize) = @_;
        eval "(( &RTOV($rp)-> &v_flag &  &VISSWAP) ==  &VISSWAP || ((($mtime). &tv_sec == ($rp)-> &r_attr. &va_mtime. &tv_sec && ($mtime). &tv_nsec == ($rp)-> &r_attr. &va_mtime. &tv_nsec) && (($fsize) == ($rp)-> &r_attr. &va_size)))";
    }';
    if (defined &_KERNEL) {
    }
    if (defined &__cplusplus) {
    }
}
1;
