if (!defined &_SYS_PARAM_H) {
    eval 'sub _SYS_PARAM_H {1;}';
    if (!defined &_ASM) {
	require 'sys/types.ph';
	require 'sys/isa_defs.ph';
    }
    if (defined &__cplusplus) {
    }
    if (!defined &_POSIX_VDISABLE) {
	eval 'sub _POSIX_VDISABLE {0;}';
    }
    if (!defined &MAX_INPUT) {
	eval 'sub MAX_INPUT {512;}';
    }
    if (!defined &MAX_CANON) {
	eval 'sub MAX_CANON {256;}';
    }
    eval 'sub UID_NOBODY {60001;}';
    eval 'sub GID_NOBODY { &UID_NOBODY;}';
    eval 'sub UID_NOACCESS {60002;}';
    eval 'sub MAXPID {30000;}';
    eval 'sub MAXUID {2147483647;}';
    eval 'sub MAXLINK {32767;}';
    eval 'sub NMOUNT {40;}';
    eval 'sub CANBSIZ {256;}';
    eval 'sub NOFILE {20;}';
    eval 'sub NGROUPS_UMIN {0;}';
    eval 'sub NGROUPS_UMAX {32;}';
    eval 'sub NGROUPS_MAX_DEFAULT {16;}';
    eval 'sub PMASK {0177;}';
    eval 'sub PCATCH {0400;}';
    eval 'sub PNOSTOP {01000;}';
    eval 'sub PSWP {0;}';
    eval 'sub PINOD {10;}';
    eval 'sub PSNDD { &PINOD;}';
    eval 'sub PAMAP { &PINOD;}';
    eval 'sub PPMAP { &PAMAP;}';
    eval 'sub PRIBIO {20;}';
    eval 'sub PZERO {25;}';
    eval 'sub PMEM {0;}';
    eval 'sub NZERO {20;}';
    eval 'sub PPIPE {26;}';
    eval 'sub PVFS {27;}';
    eval 'sub PWAIT {30;}';
    eval 'sub PLOCK {35;}';
    eval 'sub PSLEP {39;}';
    eval 'sub PUSER {60;}';
    eval 'sub PIDLE {127;}';
    eval 'sub NBPW {$sizeof{\'int\'};}';
    if (!defined &NULL) {
	eval 'sub NULL {0;}';
    }
    eval 'sub CMASK {0;}';
    eval 'sub CDLIMIT {(1 &L<<11);}';
    eval 'sub NBPS {0x20000;}';
    eval 'sub NBPSCTR {512;}';
    eval 'sub UBSIZE {512;}';
    eval 'sub SCTRSHFT {9;}';
    if (defined &_LITTLE_ENDIAN) {
	eval 'sub lobyte {
	    local($X) = @_;
	    eval "((&($X))[0])";
	}';
	eval 'sub hibyte {
	    local($X) = @_;
	    eval "((&($X))[1])";
	}';
	eval 'sub loword {
	    local($X) = @_;
	    eval "((&($X))[0])";
	}';
	eval 'sub hiword {
	    local($X) = @_;
	    eval "((&($X))[1])";
	}';
    }
    if (defined &_BIG_ENDIAN) {
	eval 'sub lobyte {
	    local($X) = @_;
	    eval "((&($X))[1])";
	}';
	eval 'sub hibyte {
	    local($X) = @_;
	    eval "((&($X))[0])";
	}';
	eval 'sub loword {
	    local($X) = @_;
	    eval "((&($X))[1])";
	}';
	eval 'sub hiword {
	    local($X) = @_;
	    eval "((&($X))[0])";
	}';
    }
    eval 'sub SYSNAME {9;}';
    eval 'sub PREMOTE {39;}';
    eval 'sub MAXPATHLEN {1024;}';
    eval 'sub MAXSYMLINKS {20;}';
    eval 'sub MAXNAMELEN {256;}';
    if (!defined &NADDR) {
	eval 'sub NADDR {13;}';
    }
    if (!defined &PIPE_BUF) {
	eval 'sub PIPE_BUF {5120;}';
    }
    if (!defined &PIPE_MAX) {
	eval 'sub PIPE_MAX {5120;}';
    }
    eval 'sub NBBY {8;}';
    eval 'sub dkblock {
        local($bp) = @_;
        eval "(($bp)-> &b_blkno)";
    }';
    eval 'sub dkunit {
        local($bp) = @_;
        eval "( &minor(($bp)-> &b_dev) >> 3)";
    }';
    eval 'sub MAXBSIZE {8192;}';
    eval 'sub DEV_BSIZE {512;}';
    eval 'sub DEV_BSHIFT {9;}';
    eval 'sub MAXFRAG {8;}';
    eval 'sub MAXOFF_T {(( &off_t)((1 <<  &NBBY * $sizeof{ &off_t} - 1) - 1));}';
    if (defined &_NO_LONGLONG) {
	eval 'sub MAXOFFSET_T { &MAXOFF_T;}';
    }
    else {
	eval 'sub MAXOFFSET_T {((1 &LL <<  &NBBY * $sizeof{ &daddr_t} +  &DEV_BSHIFT - 1) - 1);}';
    }
    eval 'sub btodb {
        local($bytes) = @_;
        eval "(($bytes) >>  &DEV_BSHIFT)";
    }';
    eval 'sub dbtob {
        local($db) = @_;
        eval "(($db) <<  &DEV_BSHIFT)";
    }';
    eval 'sub lbtodb {
        local($bytes) = @_;
        eval "(( &offset_t)($bytes) >>  &DEV_BSHIFT)";
    }';
    eval 'sub ldbtob {
        local($db) = @_;
        eval "(( &offset_t)($db) <<  &DEV_BSHIFT)";
    }';
    if (!defined &_ASM) {
	if (!defined &NODEV) {
	    eval 'sub NODEV {( &dev_t)(-1);}';
	}
    }
    eval 'sub NCARGS {0x100000;}';
    eval 'sub FSHIFT {8;}';
    eval 'sub FSCALE {(1<< &FSHIFT);}';
    if (defined( &_KERNEL) && !defined( &_ASM)) {
	eval 'sub DELAY {
	    local($n) = @_;
	    eval " &drv_usecwait($n)";
	}';
	eval 'sub CDELAY {
	    local($c, $n) = @_;
	    eval "{  &register int  &N = $n;  &while (-- &N > 0) {  &if ($c)  &break;  &drv_usecwait(1); } }";
	}';
    }
    if (defined &__cplusplus) {
    }
    if ((defined( &_KERNEL) || defined( &_KMEMUSER))) {
	if (defined( &_MACHDEP)) {
	    require 'sys/machparam.ph';
	}
	if (defined &__cplusplus) {
	}
	if (!defined( &_MACHDEP)) {
	    if (defined( &_KERNEL) && !defined( &_ASM)) {
	    }
	    eval 'sub HZ { &hz;}';
	    eval 'sub PAGESIZE { &_pagesize;}';
	    eval 'sub PAGESHIFT { &_pageshift;}';
	    eval 'sub PAGEOFFSET { &_pageoffset;}';
	    eval 'sub PAGEMASK { &_pagemask;}';
	    eval 'sub MMU_PAGESIZE { &_mmu_pagesize;}';
	    eval 'sub MMU_PAGESHIFT { &_mmu_pageshift;}';
	    eval 'sub MMU_PAGEOFFSET { &_mmu_pageoffset;}';
	    eval 'sub MMU_PAGEMASK { &_mmu_pagemask;}';
	    eval 'sub KERNELBASE { &_kernelbase;}';
	    eval 'sub USERLIMIT { &_userlimit;}';
	    eval 'sub ARGSBASE { &_argsbase;}';
	    eval 'sub MSG_BSIZE { &_msg_bsize;}';
	    eval 'sub DEFAULTSTKSZ { &_defaultstksz;}';
	    eval 'sub NBPG { &_nbpg;}';
	    eval 'sub NCPU { &_ncpu;}';
	    eval 'sub CLSIZE { &_clsize;}';
	}
	eval 'sub mmu_ptob {
	    local($x) = @_;
	    eval "(($x) <<  &MMU_PAGESHIFT)";
	}';
	eval 'sub mmu_btop {
	    local($x) = @_;
	    eval "((($x)) >>  &MMU_PAGESHIFT)";
	}';
	eval 'sub mmu_btopr {
	    local($x) = @_;
	    eval "(((($x) +  &MMU_PAGEOFFSET) >>  &MMU_PAGESHIFT))";
	}';
	eval 'sub mmu_ptod {
	    local($x) = @_;
	    eval "(($x) << ( &MMU_PAGESHIFT -  &DEV_BSHIFT))";
	}';
	eval 'sub ptod {
	    local($x) = @_;
	    eval "(($x) << ( &PAGESHIFT -  &DEV_BSHIFT))";
	}';
	eval 'sub ptob {
	    local($x) = @_;
	    eval "(($x) <<  &PAGESHIFT)";
	}';
	eval 'sub btop {
	    local($x) = @_;
	    eval "((($x)) >>  &PAGESHIFT)";
	}';
	eval 'sub btopr {
	    local($x) = @_;
	    eval "(((($x) +  &PAGEOFFSET) >>  &PAGESHIFT))";
	}';
	eval 'sub NDPP {( &PAGESIZE/ &DEV_BSHIFT);}';
	eval 'sub dtop {
	    local($DD) = @_;
	    eval "((($DD) +  &NDPP - 1) >> ( &PAGESHIFT -  &DEV_BSHIFT))";
	}';
	eval 'sub dtopt {
	    local($DD) = @_;
	    eval "(($DD) >> ( &PAGESHIFT -  &DEV_BSHIFT))";
	}';
	eval 'sub PAGOFF {
	    local($x) = @_;
	    eval "((($x)) &  &PAGEOFFSET)";
	}';
	eval 'sub NBPC { &MMU_PAGESIZE;}';
	eval 'sub NBPP { &MMU_PAGESIZE;}';
	eval 'sub BPCSHIFT { &MMU_PAGESHIFT;}';
	if (defined &__cplusplus) {
	}
    }
    else {
	require 'sys/unistd.ph';
	if (defined &__cplusplus) {
	}
	if (!defined( &_ASM)) {
	}
	eval 'sub HZ {( &_sysconf( &_SC_CLK_TCK));}';
	eval 'sub TICK {(1000000000/( &_sysconf( &_SC_CLK_TCK)));}';
	eval 'sub PAGESIZE {( &_sysconf( &_SC_PAGESIZE));}';
	eval 'sub PAGEOFFSET {( &PAGESIZE - 1);}';
	eval 'sub PAGEMASK {(~ &PAGEOFFSET);}';
	if (defined &__cplusplus) {
	}
    }
}
1;
