if (!defined &_SYS_REG_H) {
    eval 'sub _SYS_REG_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub SS {18;}';
    eval 'sub UESP {17;}';
    eval 'sub EFL {16;}';
    eval 'sub CS {15;}';
    eval 'sub EIP {14;}';
    eval 'sub ERR {13;}';
    eval 'sub TRAPNO {12;}';
    eval 'sub EAX {11;}';
    eval 'sub ECX {10;}';
    eval 'sub EDX {9;}';
    eval 'sub EBX {8;}';
    eval 'sub ESP {7;}';
    eval 'sub EBP {6;}';
    eval 'sub ESI {5;}';
    eval 'sub EDI {4;}';
    eval 'sub DS {3;}';
    eval 'sub ES {2;}';
    eval 'sub FS {1;}';
    eval 'sub GS {0;}';
    eval 'sub PC { &EIP;}';
    eval 'sub USP { &UESP;}';
    eval 'sub SP { &ESP;}';
    eval 'sub PS { &EFL;}';
    eval 'sub R0 { &EAX;}';
    eval 'sub R1 { &EDX;}';
    eval 'sub REGOFF { &MINFRAME;}';
    eval 'sub NGREG {19;}';
    if (!defined &_ASM) {
	eval 'sub r_r0 { &r_eax;}';
	eval 'sub r_r1 { &r_edx;}';
	eval 'sub r_usp { &r_uesp;}';
	eval 'sub r_sp { &r_esp;}';
	eval 'sub r_pc { &r_eip;}';
	eval 'sub r_ps { &r_efl;}';
    }
    if (defined &_KERNEL) {
	eval 'sub lwptoregs {
	    local($lwp) = @_;
	    eval "((($lwp)-> &lwp_regs))";
	}';
    }
    eval 'sub CR0_PG {0x80000000;}';
    eval 'sub CR0_CE {0x40000000;}';
    eval 'sub CR0_WT {0x20000000;}';
    eval 'sub CR0_AM {0x00040000;}';
    eval 'sub CR0_WP {0x00010000;}';
    eval 'sub CR0_NE {0x00000020;}';
    eval 'sub CR0_ET {0x00000010;}';
    eval 'sub CR0_TS {0x00000008;}';
    eval 'sub CR0_EM {0x00000004;}';
    eval 'sub CR0_MP {0x00000002;}';
    eval 'sub CR0_PE {0x00000001;}';
    eval 'sub CR3_PCD {0x00000010;}';
    eval 'sub CR3_PWT {0x00000008;}';
    eval 'sub CREGSZ {28;}';
    eval 'sub CREG_GDT {0;}';
    eval 'sub CREG_IDT {6;}';
    eval 'sub CREG_LDT {12;}';
    eval 'sub CREG_TASKR {14;}';
    eval 'sub CREG_CR0 {16;}';
    eval 'sub CREG_CR2 {20;}';
    eval 'sub CREG_CR3 {24;}';
    if (!defined &_ASM) {
	eval 'sub NDEBUGREG {8;}';
    }
    if (defined &__cplusplus) {
    }
}
1;
