if (!defined &_SYS_SYSMACROS_H) {
    eval 'sub _SYS_SYSMACROS_H {1;}';
    require 'sys/param.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub dtob {
        local($DD) = @_;
        eval "(($DD) <<  &DEV_BSHIFT)";
    }';
    eval 'sub btod {
        local($BB) = @_;
        eval "((($BB) +  &DEV_BSIZE - 1) >>  &DEV_BSHIFT)";
    }';
    eval 'sub btodt {
        local($BB) = @_;
        eval "(($BB) >>  &DEV_BSHIFT)";
    }';
    eval 'sub lbtod {
        local($BB) = @_;
        eval "((( &offset_t)($BB) +  &DEV_BSIZE - 1) >>  &DEV_BSHIFT)";
    }';
    eval 'sub ctod {
        local($x) = @_;
        eval " &mmu_ptod($x)";
    }';
    eval 'sub ctob {
        local($x) = @_;
        eval " &mmu_ptob($x)";
    }';
    eval 'sub btoc {
        local($x) = @_;
        eval " &mmu_btopr($x)";
    }';
    eval 'sub btoct {
        local($x) = @_;
        eval " &mmu_btop($x)";
    }';
    eval 'sub MIN {
        local($a, $b) = @_;
        eval "(($a) < ($b) ? ($a) : ($b))";
    }';
    eval 'sub MAX {
        local($a, $b) = @_;
        eval "(($a) < ($b) ? ($b) : ($a))";
    }';
    eval 'sub BYTE_TO_BCD {
        local($x) = @_;
        eval " &byte_to_bcd[($x) & 0xff]";
    }';
    eval 'sub BCD_TO_BYTE {
        local($x) = @_;
        eval " &bcd_to_byte[($x) & 0xff]";
    }';
    eval 'sub O_BITSMAJOR {7;}';
    eval 'sub O_BITSMINOR {8;}';
    eval 'sub O_MAXMAJ {0x7f;}';
    eval 'sub O_MAXMIN {0xff;}';
    eval 'sub L_BITSMAJOR {14;}';
    eval 'sub L_BITSMINOR {18;}';
    eval 'sub L_MAXMAJ {0x3fff;}';
    eval 'sub L_MAXMIN {0x3ffff;}';
    if (defined &_KERNEL) {
	eval 'sub major {
	    local($x) = @_;
	    eval "((($x)>> &O_BITSMINOR) &  &O_MAXMAJ)";
	}';
	eval 'sub bmajor {
	    local($x) = @_;
	    eval "((($x)>> &O_BITSMINOR) &  &O_MAXMAJ)";
	}';
	eval 'sub getmajor {
	    local($x) = @_;
	    eval "((($x)>> &L_BITSMINOR) &  &L_MAXMAJ)";
	}';
	eval 'sub minor {
	    local($x) = @_;
	    eval "(($x) &  &O_MAXMIN)";
	}';
	eval 'sub getminor {
	    local($x) = @_;
	    eval "(($x) &  &L_MAXMIN)";
	}';
    }
    else {
	eval 'sub major {
	    local($x) = @_;
	    eval "((($x) >>  &O_BITSMINOR) &  &O_MAXMAJ)";
	}';
	eval 'sub minor {
	    local($x) = @_;
	    eval "(($x) &  &O_MAXMIN)";
	}';
    }
    eval 'sub makedev {
        local($x, $y) = @_;
        eval "((($x)<< &O_BITSMINOR) | (($y)& &O_MAXMIN))";
    }';
    eval 'sub makedevice {
        local($x, $y) = @_;
        eval "((($x)<< &L_BITSMINOR) | (($y)& &L_MAXMIN))";
    }';
    eval 'sub emajor {
        local($x) = @_;
        eval "((($x)>> &O_BITSMINOR) >  &O_MAXMAJ) ?  &NODEV : ((($x)>> &O_BITSMINOR)& &O_MAXMAJ)";
    }';
    eval 'sub eminor {
        local($x) = @_;
        eval "(($x)& &O_MAXMIN)";
    }';
    eval 'sub getemajor {
        local($x) = @_;
        eval "(((($x)>> &L_BITSMINOR) >  &L_MAXMAJ) ?  &NODEV : ((($x)>> &L_BITSMINOR)& &L_MAXMAJ))";
    }';
    eval 'sub geteminor {
        local($x) = @_;
        eval "(($x)& &L_MAXMIN)";
    }';
    eval 'sub cmpdev {
        local($x) = @_;
        eval "(((($x)>> &L_BITSMINOR) >  &O_MAXMAJ || (($x)& &L_MAXMIN) >  &O_MAXMIN) ?  &NODEV : (((($x)>> &L_BITSMINOR)<< &O_BITSMINOR)|(($x)& &O_MAXMIN)))";
    }';
    eval 'sub expdev {
        local($x) = @_;
        eval "((((($x)>> &O_BITSMINOR)& &O_MAXMAJ)<< &L_BITSMINOR) | (($x)& &O_MAXMIN))";
    }';
    eval 'sub SALIGN {
        local($p) = @_;
        eval "(($p+($sizeof{\'short\'}-1)) & ~($sizeof{\'short\'}-1))";
    }';
    eval 'sub IALIGN {
        local($p) = @_;
        eval "(($p+($sizeof{\'int\'}-1)) & ~($sizeof{\'int\'}-1))";
    }';
    eval 'sub LALIGN {
        local($p) = @_;
        eval "(($p+($sizeof{\'long\'}-1)) & ~($sizeof{\'long\'}-1))";
    }';
    eval 'sub SNEXT {
        local($p) = @_;
        eval "($p + $sizeof{\'short\'})";
    }';
    eval 'sub INEXT {
        local($p) = @_;
        eval "($p + $sizeof{\'int\'})";
    }';
    eval 'sub LNEXT {
        local($p) = @_;
        eval "($p + $sizeof{\'long\'})";
    }';
    eval 'sub howmany {
        local($x, $y) = @_;
        eval "((($x)+(($y)-1))/($y))";
    }';
    eval 'sub roundup {
        local($x, $y) = @_;
        eval "(((($x)+(($y)-1))/($y))*($y))";
    }';
    eval 'sub INCR_COUNT {
        local($var, $mutex) = @_;
        eval " &mutex_enter($mutex), (*($var))++,  &mutex_exit($mutex)";
    }';
    eval 'sub DECR_COUNT {
        local($var, $mutex) = @_;
        eval " &mutex_enter($mutex), (*($var))--,  &mutex_exit($mutex)";
    }';
    if (defined &__cplusplus) {
    }
}
1;
