if (!defined &_SYS_FS_HSFS_SUSP_H) {
    eval 'sub _SYS_FS_HSFS_SUSP_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub DEBUGGING_ALL {0;}';
    eval 'sub DEBUGGING {0;}';
    eval 'sub DPRINTF { &if ( &DEBUGGING)  &printf;}';
    eval 'sub DPRINTF_ALL { &if ( &DEBUGGING_ALL)  &printf;}';
    eval 'sub SUA_NULL_POINTER {-1;}';
    eval 'sub END_OF_SUA_PARSING {-2;}';
    eval 'sub END_OF_SUA {-3;}';
    eval 'sub GET_CONTINUATION {-4;}';
    eval 'sub SUA_ENOMEM {-5;}';
    eval 'sub SUA_EINVAL {-6;}';
    eval 'sub RELOC_DIR {-7;}';
    eval 'sub SET_IMPL_BIT {
        local($fsp, $y) = @_;
        eval "(($fsp-> &ext_impl_bits) |= (0x01 &L) << ($y))";
    }';
    eval 'sub UNSET_IMPL_BIT {
        local($fsp, $y) = @_;
        eval "(($fsp-> &ext_impl_bits) &= ~((0x01 &L) << ($y)))";
    }';
    eval 'sub IS_IMPL_BIT_SET {
        local($fsp, $y) = @_;
        eval "(($fsp-> &ext_impl_bits) & ((0x01 &L) << ($y)))";
    }';
    eval 'sub HAVE_SUSP {0;}';
    eval 'sub HAVE_PROHIBITED {1;}';
    eval 'sub SET_SUSP_BIT {
        local($fsp) = @_;
        eval "( &SET_IMPL_BIT(($fsp),  &HAVE_SUSP))";
    }';
    eval 'sub UNSET_SUSP_BIT {
        local($fsp) = @_;
        eval "( &UNSET_IMPL_BIT(($fsp),  &HAVE_SUSP))";
    }';
    eval 'sub IS_SUSP_IMPLEMENTED {
        local($fsp) = @_;
        eval "( &IS_IMPL_BIT_SET($fsp, 0) ? 1 : 0)";
    }';
    eval 'sub SUSP_VERSION {1;}';
    eval 'sub SUSP_SP {"SP";}';
    eval 'sub SUSP_CE {"CE";}';
    eval 'sub SUSP_PD {"PD";}';
    eval 'sub SUSP_ER {"ER";}';
    eval 'sub SUSP_ST {"ST";}';
    eval 'sub SUF_SIG_LEN {2;}';
    eval 'sub SUF_MIN_LEN {4;}';
    eval 'sub SUF_LEN {
        local($x) = @_;
        eval "*( &SUF_len($x))";
    }';
    eval 'sub SUF_len {
        local($x) = @_;
        eval "(&($x)[2])";
    }';
    eval 'sub SUF_VER {
        local($x) = @_;
        eval "*( &SUF_ver($x))";
    }';
    eval 'sub SUF_ver {
        local($x) = @_;
        eval "(&($x)[3])";
    }';
    eval 'sub ER_ID_LEN {
        local($x) = @_;
        eval "*( &ER_id_len($x))";
    }';
    eval 'sub ER_id_len {
        local($x) = @_;
        eval "(&($x)[4])";
    }';
    eval 'sub ER_DES_LEN {
        local($x) = @_;
        eval "*( &ER_des_len($x))";
    }';
    eval 'sub ER_des_len {
        local($x) = @_;
        eval "(&($x)[5])";
    }';
    eval 'sub ER_SRC_LEN {
        local($x) = @_;
        eval "*( &ER_src_len($x))";
    }';
    eval 'sub ER_src_len {
        local($x) = @_;
        eval "(&($x)[6])";
    }';
    eval 'sub ER_EXT_VER {
        local($x) = @_;
        eval "*( &ER_ext_ver($x))";
    }';
    eval 'sub ER_ext_ver {
        local($x) = @_;
        eval "(&($x)[7])";
    }';
    eval 'sub ER_EXT_ID_LOC {8;}';
    eval 'sub ER_ext_id {
        local($x) = @_;
        eval "(&($x)[ &ER_EXT_ID_LOC])";
    }';
    eval 'sub ER_ext_des {
        local($x) = @_;
        eval "(&($x)[ &ER_EXT_ID_LOC +  &ER_ID_LEN($x)])";
    }';
    eval 'sub ER_ext_src {
        local($x) = @_;
        eval "(&($x)[ &ER_EXT_ID_LOC +  &ER_ID_LEN($x) +  &ER_DES_LEN($x)])";
    }';
    eval 'sub CE_BLK_LOC {
        local($x) = @_;
        eval " &BOTH_INT( &CE_blk_loc($x))";
    }';
    eval 'sub CE_blk_loc {
        local($x) = @_;
        eval "(&($x)[4])";
    }';
    eval 'sub CE_OFFSET {
        local($x) = @_;
        eval " &BOTH_INT( &CE_offset($x))";
    }';
    eval 'sub CE_offset {
        local($x) = @_;
        eval "(&($x)[12])";
    }';
    eval 'sub CE_CONT_LEN {
        local($x) = @_;
        eval " &BOTH_INT( &CE_cont_len($x))";
    }';
    eval 'sub CE_cont_len {
        local($x) = @_;
        eval "(&($x)[20])";
    }';
    eval 'sub SP_CHK_BYTE_1 {
        local($x) = @_;
        eval "*( &SP_chk_byte_1($x))";
    }';
    eval 'sub SP_chk_byte_1 {
        local($x) = @_;
        eval "(&($x)[4])";
    }';
    eval 'sub SP_CHK_BYTE_2 {
        local($x) = @_;
        eval "*( &SP_chk_byte_2($x))";
    }';
    eval 'sub SP_chk_byte_2 {
        local($x) = @_;
        eval "(&($x)[5])";
    }';
    eval 'sub SUSP_CHECK_BYTE_1 {0xBE;}';
    eval 'sub SUSP_CHECK_BYTE_2 {0xEF;}';
    eval 'sub CHECK_BYTES_OK {
        local($x) = @_;
        eval "(( &SP_CHK_BYTE_1($x) ==  &SUSP_CHECK_BYTE_1) && ( &SP_CHK_BYTE_2($x) ==  &SUSP_CHECK_BYTE_2))";
    }';
    eval 'sub SP_SUA_OFFSET {
        local($x) = @_;
        eval "*( &SP_sua_offset($x))";
    }';
    eval 'sub SP_sua_offset {
        local($x) = @_;
        eval "(&($x)[6])";
    }';
    if (defined &_KERNEL) {
    }
    if (defined &_KERNEL) {
    }
    if (defined &__cplusplus) {
    }
}
1;
