if (!defined &_SYS_IPD_SYS_H) {
    eval 'sub _SYS_IPD_SYS_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub IPDCM {"ipdcm";}';
    eval 'sub IPD_MTP_NAME {"ipd";}';
    eval 'sub IPD_PTP_NAME {"ipdptp";}';
    eval 'sub IPD_SAPL {0;}';
    if (!defined &IP_ADDR_LEN) {
	eval 'sub IP_ADDR_LEN {4;}';
    }
    eval 'sub IPD_MTP_ADDRL { &IP_ADDR_LEN;}';
    eval 'sub IPD_PTP_ADDRL {0;}';
    eval 'sub IPD_MTU {(8232);}';
    eval 'sub IPD_LINKHDR {(4);}';
    eval 'sub IPD_MAX_PKTS {(10);}';
    eval 'sub IPD_IF_STATIC {(-1);}';
    eval 'sub IPD_MINOR {(0);}';
    eval 'sub IPD_HOLDING_TIME {(10);}';
    eval 'sub IPD_MAXIFS {(64);}';
    eval 'sub IPD_MAXIPDCMS {(20);}';
    eval 'sub IPD_DLPI {1;}';
    eval 'sub IPD_FLOWCTRL {2;}';
    eval 'sub IPD_DDI {4;}';
    eval 'sub IPD_DATA {8;}';
    if (defined &IPD_DEBUG_MSGS) {
	eval 'sub IPD_DLPI2 {
	    local($s, $t, $q) = @_;
	    eval " &if ( &ipd_debug &  &IPD_DLPI) {  &printf($s, $t, $q); }";
	}';
	eval 'sub IPD_DLPI3 {
	    local($s, $t, $q, $u) = @_;
	    eval " &if ( &ipd_debug &  &IPD_DLPI) {  &printf($s, $t, $q, $u); }";
	}';
	eval 'sub IPD_DDIDEBUG {
	    local($s) = @_;
	    eval " &if ( &ipd_debug &  &IPD_DDI) {  &printf($s); }";
	}';
	eval 'sub IPD_DDIDEBUG1 {
	    local($s, $t) = @_;
	    eval " &if ( &ipd_debug &  &IPD_DDI) {  &printf($s, $t); }";
	}';
	eval 'sub IPD_DDIDEBUG2 {
	    local($s, $t, $v) = @_;
	    eval " &if ( &ipd_debug &  &IPD_DDI) {  &printf($s, $t, $v); }";
	}';
	eval 'sub IPD_FLDEBUG1 {
	    local($s, $t) = @_;
	    eval " &if ( &ipd_debug &  &IPD_FLOWCTRL) {  &printf($s, $t); }";
	}';
	eval 'sub IPD_DATADBG1 {
	    local($s, $t) = @_;
	    eval " &if ( &ipd_debug &  &IPD_DATA) {  &printf($s, $t); }";
	}';
	eval 'sub IPD_DEBUG {
	    local($s) = @_;
	    eval " &if ( &ipd_debug)  &printf($s)";
	}';
	eval 'sub IPD_DEBUG1 {
	    local($s, $t) = @_;
	    eval " &if ( &ipd_debug)  &printf($s, $t)";
	}';
	eval 'sub IPD_DEBUG2 {
	    local($s, $t, $q) = @_;
	    eval " &if ( &ipd_debug)  &printf($s, $t, $q)";
	}';
    }
    else {
	eval 'sub IPD_DLPI2 {
	    local($s, $t, $q) = @_;
	    eval "";
	}';
	eval 'sub IPD_DLPI3 {
	    local($s, $t, $q, $u) = @_;
	    eval "";
	}';
	eval 'sub IPD_DDIDEBUG {
	    local($s) = @_;
	    eval "";
	}';
	eval 'sub IPD_DDIDEBUG1 {
	    local($s, $t) = @_;
	    eval "";
	}';
	eval 'sub IPD_DDIDEBUG2 {
	    local($s, $t, $v) = @_;
	    eval "";
	}';
	eval 'sub IPD_FLDEBUG1 {
	    local($s, $t) = @_;
	    eval "";
	}';
	eval 'sub IPD_DATADBG1 {
	    local($s, $t) = @_;
	    eval "";
	}';
	eval 'sub IPD_DEBUG {
	    local($s) = @_;
	    eval "";
	}';
	eval 'sub IPD_DEBUG1 {
	    local($s, $t) = @_;
	    eval "";
	}';
	eval 'sub IPD_DEBUG2 {
	    local($s, $t, $q) = @_;
	    eval "";
	}';
    }
    if (!defined &DL_MAXPRIM) {
	eval 'sub DL_MAXPRIM { &DL_GET_STATISTICS_ACK;}';
    }
    eval 'sub MTYPE {
        local($mp) = @_;
        eval "($mp-> &b_datap-> &db_type)";
    }';
    eval 'sub EQUAL {
        local($a1, $a2) = @_;
        eval "( &bcmp(( &caddr_t) ($a1), ( &caddr_t) ($a2), ( &IP_ADDR_LEN)) == 0)";
    }';
    eval 'sub GETSTRUCT {
        local($structure, $number) = @_;
        eval "(($structure *)  &kmem_zalloc(  ($sizeof{$structure} * ($number)),  &KM_NOSLEEP))";
    }';
    eval 'sub GETBUF {
        local($structure, $size) = @_;
        eval "(($structure *)  &kmem_zalloc( ($size),  &KM_NOSLEEP))";
    }';
    eval 'sub DRIVER_IS {
        local($dev, $name) = @_;
        eval "( &strcmp( &ddi_major_to_name( &getmajor($dev)), $name) == 0)";
    }';
    if (defined &__cplusplus) {
    }
}
1;
